"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useIconButtonFoundation = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var base_1 = require("@rmwc/base");
var icon_button_1 = require("@material/icon-button");
var useIconButtonFoundation = function (props) {
    var _a = base_1.useFoundation({
        props: props,
        elements: { rootEl: true },
        foundation: function (_a) {
            var rootEl = _a.rootEl, emit = _a.emit;
            return new icon_button_1.MDCIconButtonToggleFoundation({
                addClass: function (className) { return rootEl.addClass(className); },
                removeClass: function (className) { return rootEl.removeClass(className); },
                hasClass: function (className) { return rootEl.hasClass(className); },
                setAttr: function (attrName, attrValue) {
                    return rootEl.setProp(attrName, attrValue);
                },
                notifyChange: function (evtData) { return emit('onChange', evtData); }
            });
        }
    }), foundation = _a.foundation, elements = tslib_1.__rest(_a, ["foundation"]);
    var rootEl = elements.rootEl;
    var isOn = props.checked !== undefined ? props.checked : foundation.isOn();
    react_1.useEffect(function () {
        if (isOn !== foundation.isOn()) {
            foundation.toggle(isOn);
        }
    }, [foundation, isOn]);
    var handleClick = function (evt) {
        var _a;
        (_a = props.onClick) === null || _a === void 0 ? void 0 : _a.call(props, evt);
        foundation.handleClick();
    };
    rootEl.setProp('onClick', handleClick, true);
    return tslib_1.__assign({ isOn: isOn, foundation: foundation }, elements);
};
exports.useIconButtonFoundation = useIconButtonFoundation;
